#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "server.h"
#include "ticktime.h"
#include "signals.h"
#include "main.h"

#ifndef _WIN32
#define strcpy_s strcpy
#endif

char appPath[APP_PATH_LEN];

int main(int argc, char *args[])
{

	InitSignals();
	#ifdef _WIN32
	WSADATA wsa;
	WSAStartup(0x202, &wsa);
	#endif

	if (argc < 2)
	{
		fprintf(stderr, "Usage: dynmsg <port>\n");
		return 1;
	}


	strcpy_s(appPath, args[0]);
	char *c = appPath;
	while(*c) c++;
	while(c >= appPath && *c!='/' && *c!='\\') c--;
	c++;
	*c = 0;

	printf("%s\n", appPath);




	int port = atoi(args[1]);
	if (port == 0)
	{
		fprintf(stderr, "Invalid port!\n");
		return 1;
	}

	if (!server.Open((unsigned short)port))
	{
		fprintf(stderr, "Can't open serevr at port %d!\n", port);
		return 1;
	}
	printf("Server is open at port %d\n", port);

	int oldT = (int)GetTickCount();
	while(!closing)
	{
		int T = (int)GetTickCount();
		int dT = T - oldT;
		oldT = T;

		if (dT > 250) dT = 250;
		server.Tick(dT);
		Sleep(20);
	}
	return 0;
}
