#ifndef __MSG_SERVER__
#define __MSG_SERVER__


#include <stdlib.h>
#include "streams.h"

#ifdef _WIN32
#include <windows.h>
#define socklen int
#else


#include <sys/types.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/ioctl.h>
#include <netdb.h>
#include <time.h>

#define SOCKET	int
#define INVALID_SOCKET	-1
#define SOCKET_ERROR -1
#define closesocket	::close

#endif

class Connection
{
public:
	SOCKET handle;
	int timer;

	CMemoryStream inData;
	CMemoryStream outData;
	

	Connection *next, *prev;

	Connection(SOCKET s);
	~Connection();
	void Tick(int dT);
	void SendFastCommands();
	void Send(const char *text);
};


#define SERVER_SAVE_MESSAGE_COUNT	3

class Server
{
public:
	SOCKET handle;
	unsigned short port;

	Connection *connections;

	char *messages[SERVER_SAVE_MESSAGE_COUNT];



	Server();
	~Server();
	bool Open(unsigned short port);
	void Close();
	void Tick(int dT);

};

extern Server server;



#endif