#ifdef _WIN32
#include <Windows.h>
#endif

volatile bool closing = false;

void OnCtrlBreak()
{
	closing = true;
}


#ifndef _WIN32

#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

void DoneAll()
{
	exit(0);
}

void sigtermHandler( int signo )
{
	printf("Signal [%d]\n", signo);
	signal( SIGTERM, SIG_IGN );
	signal( SIGQUIT, SIG_IGN );
	signal( SIGINT, SIG_IGN );

	OnCtrlBreak();

	signal( SIGTERM, sigtermHandler );
	signal( SIGQUIT, sigtermHandler );
	signal( SIGINT, sigtermHandler );
}

void sigsegvHandler( int signo )
{
	printf("Signal [%d]\n", signo);
	signal( SIGSEGV, SIG_IGN );
	OnCtrlBreak();
	printf("General Protection Fault!\n");
	DoneAll();
	exit(0);
}

void InitSignals()
{
	signal( SIGTERM, sigtermHandler );
	signal( SIGQUIT, sigtermHandler );
	signal( SIGINT,  sigtermHandler );
	signal( SIGFPE, SIG_IGN );
	signal( SIGPIPE, SIG_IGN );
	signal( SIGHUP,  SIG_IGN );
	signal( SIGXCPU,  SIG_IGN );
	signal( SIGUSR1, SIG_IGN );
	signal( SIGUSR2, SIG_IGN );
	signal( SIGSEGV, sigsegvHandler );
	
}

#else
#include <windows.h>

BOOL WINAPI CtrlBreakHandler(DWORD dwCtrlType)   //  control signal type
{
	OnCtrlBreak();
	return TRUE;
}

void InitSignals()
{
	SetConsoleCtrlHandler( (PHANDLER_ROUTINE)CtrlBreakHandler, TRUE);
}
#endif
